#include "glut.h"
#include <vector>


//! 
struct vector_3d{
	double x;
	double y;
	double z;
	vector_3d(double x0=0,double y0=0,double z0=0);
	void operator +=(vector_3d &obj);
	void operator -=(vector_3d &obj);
	void operator /=(double);
	friend vector_3d operator*(vector_3d &obj,double d);
	friend double operator*(vector_3d &obj1,vector_3d &obj2);
	operator double();	//!<  
};


//!  ()
struct CObj{
	COLORREF color;		//!< 
	int r;				//!<  
	double m;			//!<  
	vector_3d offset;	//!< 
	vector_3d speed;	//!< 
	bool isStand();		//!<   
	CObj(COLORREF,vector_3d&,int r0=10,vector_3d &speed=vector_3d());
};


class Engine {
	SIZE size;										//!<  
	GLfloat f1,f2;									//!<  
	std::vector<CObj>m_list;						//!<  
	GLvoid InitScene();								//!<   
	GLvoid CheckBorder(CObj*);						//!<    
	GLvoid CheckCollision(int index,CObj*);			//!<   
public:
	Engine();
	GLvoid Resize(GLsizei width, GLsizei height);	//!< ,     
	GLvoid Init();									//!< ,    
	GLvoid Draw();									//!<  (render) 
	GLvoid Step();									//!<   
	GLvoid Move(int,int);							//!<  
};


