#include "engine.h"

Engine *engine;

GLvoid display()
{
	engine->Draw();
	glutSwapBuffers();
}

GLvoid Step(GLint)
{
	engine->Step();
	display();
	glutTimerFunc(40,Step,0);
}

GLvoid reshape(GLsizei width, GLsizei height)
{
	engine->Resize(width, height);
}

GLvoid mouse(GLint x,GLint y)
{
	static GLint x0=-1;
	static GLint y0=-1;
	if(x0>0) engine->Move(x0-x,y0-y);
	x0=x; y0=y;
}


int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA);
	glutInitWindowSize(800, 600);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("Balls");
	engine = new Engine();
	engine->Init();
	glutDisplayFunc(display);
	glutMotionFunc(mouse);
	glutReshapeFunc(reshape);
	glutTimerFunc(40,Step,0);
	glutMainLoop();
	delete engine;
	return 0;
}
